package eu.etaxonomy.taxeditor;

import org.eclipse.ui.IFolderLayout;
import org.eclipse.ui.IPageLayout;
import org.eclipse.ui.IPerspectiveFactory;
import org.eclipse.ui.progress.IProgressConstants;

import eu.etaxonomy.taxeditor.navigation.navigator.TaxonNavigator;
import eu.etaxonomy.taxeditor.navigation.search.SearchResultView;

public class Perspective implements IPerspectiveFactory {

	public static final String ID = "eu.etaxonomy.taxeditor.application.perspective";
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IPerspectiveFactory#createInitialLayout(org.eclipse.ui.IPageLayout)
	 */
	public void createInitialLayout(IPageLayout layout) {
		IFolderLayout navigationFolder = layout.createFolder("searchResults", IPageLayout.LEFT, 0.25f,
			    layout.getEditorArea());
		
		// Note: ":*" is what allows us to call multiple searchResultView's with unique secondaryIds;
		//	this can only be done here, with a placeholder, not in plugin.xml
		navigationFolder.addPlaceholder(SearchResultView.ID + ":*");
//		navigationFolder.addView(TaxonomicTreeView.ID);
		navigationFolder.addView(TaxonNavigator.ID);
		
		navigationFolder.addPlaceholder(IProgressConstants.PROGRESS_VIEW_ID);
	}
}