/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.forms.widgets.Section;
import org.eclipse.ui.forms.widgets.ToggleHyperlink;

import eu.etaxonomy.cdm.model.description.DescriptionElementBase;
import eu.etaxonomy.taxeditor.forms.AbstractEditorFormSection;

/**
 * @author nho
 *
 */
public abstract class AbstractDescriptionDetailSection extends AbstractEditorFormSection implements IPropertyChangeListener{

	protected AbstractDescriptionDetailsPage page;
	private Composite client;
	
	/**
	 * @param parent
	 * @param style
	 */
	public AbstractDescriptionDetailSection(Composite parent, AbstractDescriptionDetailsPage page, int sectionStyle) {
		super(parent, page, Section.TITLE_BAR | SWT.NO_BACKGROUND | sectionStyle);
		this.page = page;
				
		this.setLayoutData(new GridData(SWT.FILL, SWT.TOP, true, false));
		
		client = toolkit.createComposite(this, SWT.WRAP);
		client.setLayout(new GridLayout());

		createDynamicContents();
		
		this.setClient(client);
		this.addExpansionListener(this);
	}
	
	public Composite getClient(){
		return client;
	}
	
	public abstract void updateSection();
	
	/**
	 * create controls that will change dynamically here
	 */
	protected void createDynamicContents(){
		// default is empty
	}
	
	public DescriptionElementBase getDescriptionElement() {
		return page.getDescriptionElement();
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.util.IPropertyChangeListener#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	public void propertyChange(PropertyChangeEvent event) {
		page.propertyChange(event);
	}
	
	public ToggleHyperlink getToggle(){
		return toggle;
	}
}
