/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;

/**
 * Edit the label for a TaxonDescription, or for a DescriptionElementBase whose cache is used
 * as a label, e.g. a DescriptionElementBase which contains an image list.
 * 
 * @author p.ciardelli
 * @author n.hoffmann
 *
 */
public class LabelDetailsPage extends AbstractDescriptionDetailsPage{
	
	private String sectionHeader;
	private String description;
	
	public LabelDetailsPage(String sectionHeader, String description) {
		this.sectionHeader = sectionHeader; 
		this.description = description;
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailsPage#configurePage()
	 */
	@Override
	void configurePage() {
		// add nothing
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.editor.descriptiontree.detailpage.AbstractDescriptionDetailsPage#createDescriptionContents(org.eclipse.swt.widgets.Composite)
	 */
	@Override
	protected void createDescriptionContents(Composite parent) {
		descriptionSection = new LabelDetailsSection(parent, this, sectionHeader, description, SWT.WRAP);
		toolkit.adapt(descriptionSection);
	}
}