/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.Credit;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.forms.selectioncomposites.AgentSelectionComposite;

/**
 * 
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class CreditComposite extends AbstractEntitySetElementComposite<Credit>{

	private AgentSelectionComposite agentSelection;
	private MultilineTextWithLabel text;
	
	/**
	 * @param parent
	 * @param style
	 */
	public CreditComposite(Composite parent, Credit credit, SelectionListener removeListener, IPropertyChangeListener propertyChangeListener, int style) {
		super(parent, credit, removeListener, propertyChangeListener, style);
	}
	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractFormComposite#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		element.setAgent(agentSelection.getSelection());
		element.setText(text.getText());
		
		super.propertyChange(event);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		agentSelection = new AgentSelectionComposite(parent, "Agent", null, this, style);
		text = toolkit.createMultilineTextWithLabel(parent, "Text", this, 100, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.AnnotatableEntity)
	 */
	@Override
	public void setElement(Credit element) {
		this.element = element;
		
		agentSelection.setSelection(element.getAgent());
		text.setText(element.getText());
	}

}
