/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.common.Marker;
import eu.etaxonomy.taxeditor.forms.CheckboxComposite;
import eu.etaxonomy.taxeditor.forms.termcombos.MarkerTypeComboComposite;

/**
 * 
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class MarkerComposite extends AbstractEntitySetElementComposite<Marker>{

	/**
	 * @param parent
	 * @param element
	 * @param removeListener
	 * @param propertyChangelistener
	 * @param style
	 */
	public MarkerComposite(Composite parent, Marker element,
			SelectionListener removeListener,
			IPropertyChangeListener propertyChangelistener, int style) {
		super(parent, element, removeListener, propertyChangelistener, style);
	}
	
	private MarkerTypeComboComposite markerTypeCombo;
	private CheckboxComposite markerStateCheckbox;


	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractFormComposite#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		element.setMarkerType(markerTypeCombo.getSelection());
		element.setFlag(markerStateCheckbox.getSelection());

		super.propertyChange(event);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		parent.setLayout(new GridLayout(2, false));
		
		markerStateCheckbox = toolkit.createCheckbox(parent, null, false, this);
		
		markerTypeCombo = new MarkerTypeComboComposite(parent, null, null, this, style);
		markerTypeCombo.setLayoutData(FILL_GRID_HORIZONTALLY());
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.VersionableEntity)
	 */
	@Override
	public void setElement(Marker element) {
		this.element = element;
		markerStateCheckbox.setSelection(element.getFlag());
		markerTypeCombo.setSelection(element.getMarkerType());
	}
}
