// $Id$
/**
* Copyright (C) 2007 EDIT
* European Distributed Institute of Taxonomy 
* http://www.e-taxonomy.eu
* 
* The contents of this file are subject to the Mozilla Public License Version 1.1
* See LICENSE.TXT at the top of this package for the full license terms.
*/

package eu.etaxonomy.taxeditor.forms.entitysections;

import org.apache.log4j.Logger;
import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.name.NomenclaturalStatus;
import eu.etaxonomy.taxeditor.forms.TextWithLabelComposite;
import eu.etaxonomy.taxeditor.forms.termcombos.NomenclaturalStatusTypeComboComposite;

/**
 * @author n.hoffmann
 * @created Nov 5, 2009
 * @version 1.0
 */
public class NomenclaturalStatusComposite extends AbstractEntitySetElementComposite<NomenclaturalStatus> {
	/**
	 * @param parent
	 * @param element
	 * @param removeListener
	 * @param propertyChangelistener
	 * @param style
	 */
	public NomenclaturalStatusComposite(Composite parent,
			NomenclaturalStatus element, SelectionListener removeListener,
			IPropertyChangeListener propertyChangelistener, int style) {
		super(parent, element, removeListener, propertyChangelistener, style);
	}

	private static final Logger logger = Logger
			.getLogger(NomenclaturalStatusComposite.class);
	

	private NomenclaturalStatusTypeComboComposite nomenclaturalStatusTypeCombo;

	private TextWithLabelComposite ruleConsideredText;
	
	private static final int VISIBLE_ITEMS = 10;



	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractFormComposite#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		element.setType(nomenclaturalStatusTypeCombo.getSelection());
		element.setRuleConsidered(ruleConsideredText.getText());		
		
		super.propertyChange(event);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		nomenclaturalStatusTypeCombo = new NomenclaturalStatusTypeComboComposite(parent, "Nomenclatural Status", null, this, VISIBLE_ITEMS, style);
		ruleConsideredText = toolkit.createTextWithLabelComposite(parent, "Rule Considered", "", this, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.VersionableEntity)
	 */
	@Override
	public void setElement(NomenclaturalStatus element) {
		this.element = element;
		
		nomenclaturalStatusTypeCombo.setSelection(element.getType());
		ruleConsideredText.setText(element.getRuleConsidered());
	}
}
