/**
 * 
 */
package eu.etaxonomy.taxeditor.forms.entitysections;

import org.eclipse.jface.util.IPropertyChangeListener;
import org.eclipse.jface.util.PropertyChangeEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.widgets.Composite;

import eu.etaxonomy.cdm.model.media.Rights;
import eu.etaxonomy.taxeditor.forms.AbstractFormComposite;
import eu.etaxonomy.taxeditor.forms.MultilineTextWithLabel;
import eu.etaxonomy.taxeditor.forms.selectioncomposites.AgentSelectionComposite;
import eu.etaxonomy.taxeditor.forms.termcombos.RightsTypeComboComposite;

/**
 * 
 * @author n.hoffmann
 * @created Nov 16, 2009
 * @version 1.0
 */
public class RightsComposite extends AbstractEntitySetElementComposite<Rights> {

	/**
	 * @param parent
	 * @param element
	 * @param removeListener
	 * @param propertyChangelistener
	 * @param style
	 */
	public RightsComposite(Composite parent, Rights element,
			SelectionListener removeListener,
			IPropertyChangeListener propertyChangelistener, int style) {
		super(parent, element, removeListener, propertyChangelistener, style);
	}

	private RightsTypeComboComposite rightsTypeCombo;
	private AgentSelectionComposite agentSelection;
	private MultilineTextWithLabel text;
	


	
	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.AbstractFormComposite#propertyChange(org.eclipse.jface.util.PropertyChangeEvent)
	 */
	@Override
	public void propertyChange(PropertyChangeEvent event) {
		element.setType(rightsTypeCombo.getSelection());
		element.setAgent(agentSelection.getSelection());
		element.setText(text.getText());
		
		super.propertyChange(event);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#createControls(org.eclipse.swt.widgets.Composite, int)
	 */
	@Override
	public void createControls(Composite parent, int style) {
		rightsTypeCombo = new RightsTypeComboComposite(parent, "Rights Type", null, this, style);
		agentSelection = new AgentSelectionComposite(parent, "Agent", null, this, style);
		text = toolkit.createMultilineTextWithLabel(parent, "Text", this, 100, style);
	}

	/* (non-Javadoc)
	 * @see eu.etaxonomy.taxeditor.forms.entitysections.AbstractEntitySetElementComposite#setElement(eu.etaxonomy.cdm.model.common.VersionableEntity)
	 */
	@Override
	public void setElement(Rights element) {
		this.element = element;
		rightsTypeCombo.setSelection(element.getType());
		agentSelection.setSelection(element.getAgent());
		text.setText(element.getText());
	}

}
