package eu.etaxonomy.taxeditor.propertysheet;

import eu.etaxonomy.cdm.model.common.Extension;
import eu.etaxonomy.cdm.model.common.IdentifiableEntity;

public class ExtensionPropertySource extends CollectionPropertySource {

	private IdentifiableEntity entity;

	public ExtensionPropertySource(IdentifiableEntity entity) {
		super(entity.getExtensions());
		
		this.entity = entity;
	}
	
	@Override
	protected String getItemDisplayName(Object item) {
		if (item instanceof Extension) {
			Extension extension = (Extension) item;
			return extension.getType().getLabel();			
		}
		return "";
	}

	@Override
	public Object getPropertyValue(Object id) {
		if (id instanceof Extension) {
			Extension extension = (Extension) id;
			return extension.getValue();
		}
		return null;
	}

	@Override
	public void setPropertyValue(Object id, Object value) {
		// Fields not editable in property sheet view
	}

	@Override
	public String toString() {
		// "Extensions" header has no value
		return "";
	}
}